From 423b807f2d227ee7052f848bb0ca9029a8ff68f9 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?=D0=90=D0=BB=D0=B5=D0=BA=D1=81=D0=B0=D0=BD=D0=B4=D1=80=20?=
 =?UTF-8?q?=D0=A5=D1=83=D1=85=D0=BB=D0=B0=D0=B5=D0=B2?=
 <sancheolz@gmail.com>
Date: Fri, 11 Jun 2021 20:47:49 +0300
Subject: [PATCH] [WinForms] Fix changing reference to PrintController in
 preview in PrintPreviewControl (#21010)

If a reference to PrintDocument is passed to PrintPreviewControl, and then this control is displayed on the form,
then original PrintController of the PrintDocument will be replaced by previewController and if you call print for PrintController,
then the print page will not be sent to printer.
---
 .../System.Windows.Forms/PrintPreviewControl.cs                | 3 +++
 .../Test/System.Windows.Forms/PrintPreviewControlTest.cs       | 2 ++
 2 files changed, 5 insertions(+)

diff --git a/mcs/class/System.Windows.Forms/System.Windows.Forms/PrintPreviewControl.cs b/mcs/class/System.Windows.Forms/System.Windows.Forms/PrintPreviewControl.cs
index a9c39185310bb..8c1e78498d3c9 100644
--- a/mcs/class/System.Windows.Forms/System.Windows.Forms/PrintPreviewControl.cs
+++ b/mcs/class/System.Windows.Forms/System.Windows.Forms/PrintPreviewControl.cs
@@ -184,10 +184,13 @@ internal void GeneratePreview ()
 
 			try {
 				if (page_infos == null) {
+					var prevPrintController = document.PrintController;
+
 					if (document.PrintController == null || !(document.PrintController is PrintControllerWithStatusDialog)) {
 						document.PrintController = new PrintControllerWithStatusDialog (controller);
 					}
 					document.Print ();
+					document.PrintController = prevPrintController;
 					page_infos = controller.GetPreviewPageInfo ();
 				}
 				
diff --git a/mcs/class/System.Windows.Forms/Test/System.Windows.Forms/PrintPreviewControlTest.cs b/mcs/class/System.Windows.Forms/Test/System.Windows.Forms/PrintPreviewControlTest.cs
index 402d42db63c50..0600771556ea7 100644
--- a/mcs/class/System.Windows.Forms/Test/System.Windows.Forms/PrintPreviewControlTest.cs
+++ b/mcs/class/System.Windows.Forms/Test/System.Windows.Forms/PrintPreviewControlTest.cs
@@ -54,6 +54,7 @@ public void StartPage ()
 				int page_count = 1;
 				document.BeginPrint += (sender, e) => page_number = 0;
 				document.PrintPage += (sender, e) => e.HasMorePages = ++page_number < page_count;
+				var printController = document.PrintController;
 
 				p.Document = document;
 				p.Refresh ();
@@ -63,6 +64,7 @@ public void StartPage ()
 				p.InvalidatePreview ();
 				p.Refresh ();
 				Assert.AreEqual (4, p.StartPage);
+				Assert.AreEqual(printController, document.PrintController);
 			}
 		}
 	}
